/*
 * core.c
 *
 *  Created on: Mar 14, 2023
 *      Author: hussamaldean
 */


#include "stm32f1xx.h"

void SystemInit(void)
{

	RCC->CFGR &= ~RCC_CFGR_PLLMULL_Msk; //Clear
	RCC->CFGR |= (0x7UL << RCC_CFGR_PLLMULL_Pos);
	//USB Prescaler = 1.5
	RCC->CFGR &= ~(0x1UL << 22);
	//Enable HSE Clock
	RCC->CR |= RCC_CR_HSEON;
	//Wait for HSE to be stable and ready to use
	while((RCC->CR & RCC_CR_HSERDY) == 0);
	//HSE as PLL source
	RCC->CFGR |= RCC_CFGR_PLLSRC;

	//Enable the PLL
	RCC->CR |= RCC_CR_PLLON;
	//Wait until PLL is ready
	while((RCC->CR & RCC_CR_PLLRDY) == 0);
	FLASH->ACR = FLASH_ACR_PRFTBE | FLASH_ACR_LATENCY_1;

	//Select PLL as main System Clock source
	RCC->CFGR &= ~RCC_CFGR_SW;
	RCC->CFGR |= RCC_CFGR_SW_1;
	//Wait until PLL system source is active
	while((RCC->CFGR & RCC_CFGR_SWS) != RCC_CFGR_SWS_1);

	//AHB Prescaler = 1
	RCC->CFGR &= ~RCC_CFGR_HPRE;
	//APB1 divider=2
	RCC->CFGR &= ~RCC_CFGR_PPRE1;
	RCC->CFGR |= RCC_CFGR_PPRE1_2;
	//APB2 divider=1
	RCC->CFGR &= ~RCC_CFGR_PPRE2;
	//ADC prescalar = 12
	RCC->CFGR &= ~RCC_CFGR_ADCPRE;
	RCC->CFGR |= RCC_CFGR_ADCPRE_1;

}
